---
title: RTCIceTransport.onstatechange
slug: Web/API/RTCIceTransport/onstatechange
tags:
  - API
  - Audio
  - Change
  - Event Handler
  - Media
  - Property
  - RTCIceTransport
  - Reference
  - Video
  - WebRTC
  - WebRTC API
  - onstatechange
  - rtc
  - state
  - statechange
---
<div>{{APIRef("WebRTC")}}</div>

<p><span class="seoSummary">The <code><strong>onstatechange</strong></code> event handler for the {{domxref("RTCIceTransport")}} interface is a property which specifies a function to serve as the {{domxref("EventHandler")}} for the {{event("statechange")}} event that is fired whenever the transport's {{domxref("RTCIceTransport.state", "state")}} changes.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>RTCIceTransport</em>.onstatechange = <em>stateChangeHandler</em>;
</pre>

<h3 id="Value">Value</h3>

<p>Set this property to reference a function you provide that is called by the WebRTC layer when the {{domxref("RTCIceTransport")}} object's {{domxref("RTCIceTransport.state", "state")}} changes.</p>

<p>The event handler receives as its sole input an {{domxref("Event")}} object describing the {{event("statechange")}} event which occurred. To determine the new state, examine the value of {{domxref("RTCIceTransport.state", "state")}}.</p>

<h2 id="Example">Example</h2>

<p>This snippet establishes a handler for the {{event("statechange")}} event that looks to see if the transport has entered the <code>"failed"</code> state, which indicates that the connection has failed with no chance of being automatically restored.</p>

<pre class="brush: js">var iceTransport = pc.getSenders()[0].transport.iceTransport;

iceTransport.onstatechange = function(event) {
  if (iceTransport.state == "failed") {
    handleFailure(pc);
  }
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('WebRTC 1.0', '#dom-rtcicetransport-onstatechange', 'RTCIceTransport.onstatechange')}}</td>
   <td>{{Spec2('WebRTC 1.0')}}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCIceTransport.onstatechange")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The {{event("statechange")}} event and its type, {{domxref("Event")}}.</li>
 <li>The other event handlers for <code>RTCIceTransport</code>: {{domxref("RTCIceTransport.ongatheringstatechange", "ongatheringstatechange")}} and {{domxref("RTCIceTransport.onselectedcandidatepairchange", "onselectedcandidatepairchange")}}</li>
</ul>
